package trc.magnets.sunray;

import java.io.IOException;

import org.lwjgl.opengl.GL11;
import org.lwjgl.util.Color;

import trc.magnets.math.Vector2f;

public class Entity
{
	static STextureData tex = null;
	
	Vector2f position = new Vector2f(500.0f, 400.0f);
	Vector2f size = new Vector2f(15.0f, 15.0f);
	
	Vector2f velocity = new Vector2f(0.0f, 0.0f);	//just a normal velocity ;)
	
	FlockAI ai;
	
	Color color = (Color) Color.RED;
	
	static final float ENTITY_SPEED = 70.0f;
	
	Entity(FlockAI controller)
	{
		ai = controller;
		if(tex == null)
		{
			try
			{
				tex = Main.textureLoader.LoadTexture("data/pig.png");
			}
			catch (IOException e)
			{
				e.printStackTrace();
			}
		}
	}
	
	void Update(float dT)
	{
		ai.AcquireNewVelocity(this);
		position.AddScaled(velocity, dT);
	}
	
	void RenderSelf()
	{
		GL11.glColor4ub(color.getRedByte(), color.getGreenByte(), color.getBlueByte(), color.getAlphaByte());
		//draw a quad
		Main.DrawQuad(position, size, tex);
	}
}
