package trc.magnets.sunray;

import org.lwjgl.Sys;
import org.lwjgl.input.Keyboard;
import org.lwjgl.openal.AL;
import org.lwjgl.opengl.Display;
import org.lwjgl.opengl.GL11;
import org.lwjgl.util.Color;

import trc.magnets.math.Vector2f;

public class Main
{
	public static final String GAME_TITLE = "TRC :: CAKE :: LWJGL";
	
	/** Exit the game */
	private static boolean bFinished;
  
	/** A rotating square! */
	private static float angle;
	
	protected static long lastFrameTime;	//last frame time in ticks
	
	public static PlayerCow player;
	
	public static TextureLoader textureLoader = new TextureLoader();
	
	public static FlockAI pigs;
	
	public static STextureData map;
	public static Vector2f mapSize = new Vector2f(400.0f, 300.0f);
	public static Vector2f mapPos = new Vector2f(400.0f, 300.0f);
	
	// ==== ==== TOOLKIT ==== ====
	public static void DrawQuad(Vector2f position, Vector2f size, STextureData tex)
	{
		GL11.glBindTexture(GL11.GL_TEXTURE_2D, tex.textureID);
		GL11.glBegin(GL11.GL_QUADS);
		
//		GL11.glTexCoord2f(texCoordXMin + offsetTexCoordX, texCoordYMax + offsetTexCoordY);
//		GL11.glVertex2f(where.x - size.x, where.y - size.y);
//		
//		GL11.glTexCoord2f(texCoordXMax + offsetTexCoordX, texCoordYMax + offsetTexCoordY);
//		GL11.glVertex2f(where.x + size.x, where.y - size.y);
//		
//		GL11.glTexCoord2f(texCoordXMax + offsetTexCoordX, texCoordYMin + offsetTexCoordY);
//		GL11.glVertex2f(where.x + size.x, where.y + size.y);
//		
//		GL11.glTexCoord2f(texCoordXMin + offsetTexCoordX, texCoordYMin + offsetTexCoordY);
//		GL11.glVertex2f(where.x - size.x, where.y + size.y);
		
		GL11.glTexCoord2f(0.0f, 1.0f);
		GL11.glVertex2f(position.x-size.x, position.y-size.y);
		GL11.glTexCoord2f(0.0f, 0.0f);
		GL11.glVertex2f(position.x-size.x, position.y+size.y);
		GL11.glTexCoord2f(1.0f, 0.0f);
		GL11.glVertex2f(position.x+size.x, position.y+size.y);
		GL11.glTexCoord2f(1.0f, 1.0f);
		GL11.glVertex2f(position.x+size.x, position.y-size.y);
		
		GL11.glEnd();
	}
	
	
	/**
	 * Initialize the game
	 * @throws Exception if init fails
	 */
	private static void Init() throws Exception
	{
		//vvvvvvvvvvvvvvvv kod przygotowany przed Compo
		
		// Create a fullscreen window with 1:1 orthographic 2D projection, and with
		// mouse, keyboard, and gamepad inputs.
		Display.setDisplayMode( new org.lwjgl.opengl.DisplayMode(800, 600) );
	    Display.setTitle(GAME_TITLE);
	    Display.setFullscreen(false);
	
	    // Enable vsync if we can
	    Display.setVSyncEnabled(false);
			
	    Display.create();
			
		// Start up the sound system
		AL.create();
			
		// TODO: Load in your textures etc here
		
		// Put the window into orthographic projection mode with 1:1 pixel ratio.
		GL11.glMatrixMode(GL11.GL_PROJECTION);
		GL11.glLoadIdentity();
		GL11.glOrtho(0.0, Display.getDisplayMode().getWidth(), 0.0, Display.getDisplayMode().getHeight(), -1.0, 1.0);
		GL11.glMatrixMode(GL11.GL_MODELVIEW);
		GL11.glLoadIdentity();
		GL11.glViewport(0, 0, Display.getDisplayMode().getWidth(), Display.getDisplayMode().getHeight());
		
		//^^^^^^^^^^^^^^^^ koniec kodu przygotowanego przed Compo
		
		GL11.glEnable(GL11.GL_TEXTURE_2D);
		GL11.glEnable(GL11.GL_BLEND);
		GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
		GL11.glEnable(GL11.GL_LINE_SMOOTH);
		
		//game objects
		player = new PlayerCow();
		
		pigs = new FlockAI(player);
		
		//place some random pigs
		Entity pig;
		for(int i = 0 ; i < 10 ; ++i)
		{
			pig = new Entity(pigs);
			pig.position.SetTo(pig.position.x + (float)Math.random()*100.0f - 50.0f, pig.position.y + (float)Math.random()*100.0f - 50.0f);
			pigs.AddEntity(pig);
		}
		
		map = textureLoader.LoadTexture("data/map.png");
		
		
	}
	
	/**
	 * Runs the game (the "main loop")
	 */
	private static void Run()
	{
		//vvvvvvvvvvvvvvvv kod przygotowany przed Compo
		//main loop
		lastFrameTime = Sys.getTime();
		long currentTime = 0;
		float dT;
		while (!bFinished)
		{
			//compute frame delta time
			currentTime = Sys.getTime();
			//first do all possible computation on longs, then convert to float
			//in order to maintain computation accuracy
			dT = ((float)(currentTime - lastFrameTime))/Sys.getTimerResolution();
			lastFrameTime = currentTime;
			
			
			//update lwjgl
			Display.update();
			
			if (Display.isCloseRequested())
			{
				// Check for O/S close requests
				bFinished = true;
			}
			else
			{
				// The window is in the foreground, so we should play the game
				Update(dT);
				Render();
			}
		}
		//^^^^^^^^^^^^^^^^ koniec kodu przygotowanego przed Compo
	}
	
	/**
	 * Do any game-specific cleanup
	 */
	private static void Cleanup()
	{
		//vvvvvvvvvvvvvvvv kod przygotowany przed Compo

		// Stop the sound
		AL.destroy();
		
		// Close the window
		Display.destroy();
		//^^^^^^^^^^^^^^^^ koniec kodu przygotowanego przed Compo
	}
	
	/**
	 * Do all calculations, handle input, etc.
	 */
	private static void Update(float dT)
	{
		//cala funkcja idzie na przemial
		
		// Example input handler: we'll check for the ESC key and finish the game instantly when it's pressed
		if (Keyboard.isKeyDown(Keyboard.KEY_ESCAPE))
		{
			bFinished = true;
		}

		player.Update(dT);
		pigs.Update(dT);
	}
	
	/**
	 * Render the current frame
	 */
	private static void Render()
	{
		//vvvvvvvvvvvvvvvv kod przygotowany przed Compo
		
		GL11.glClear(GL11.GL_COLOR_BUFFER_BIT | GL11.GL_STENCIL_BUFFER_BIT);
		
		//^^^^^^^^^^^^^^^^ koniec kodu przygotowanego przed Compo

		GL11.glDisable(GL11.GL_TEXTURE_2D);
		GL11.glColor4ub(Color.WHITE.getRedByte(), Color.WHITE.getGreenByte(), Color.WHITE.getBlueByte(), Color.WHITE.getAlphaByte());
	    // TODO: all your rendering goes here
	    GL11.glClear(GL11.GL_COLOR_BUFFER_BIT);
	    GL11.glPushMatrix();
	    GL11.glTranslatef(Display.getDisplayMode().getWidth() / 2, Display.getDisplayMode().getHeight() / 2, 0.0f);
	    GL11.glRotatef(angle, 0, 0, 1.0f);
	    GL11.glBegin(GL11.GL_QUADS);
	    GL11.glVertex2i(-50, -50);
	    GL11.glVertex2i(50, -50);
	    GL11.glVertex2i(50, 50);
	    GL11.glVertex2i(-50, 50);
	    GL11.glEnd();
	    GL11.glPopMatrix();
	    
	    //render map
	    GL11.glEnable(GL11.GL_TEXTURE_2D);
	    
	    DrawQuad(mapPos, mapSize, map);
	    
	    //render player
	    player.RenderSelf();
	    
	    //render other entities
	    pigs.RenderAll();
	}

	/**
	 * @param args
	 */
	public static void main(String[] args)
	{
		System.out.println("Hey, hi, hello!");
		try
		{
			Init();
			Run();
		}
		catch (Exception e)
		{
			e.printStackTrace(System.err);
			Sys.alert(GAME_TITLE, "An error occured and the game will exit.");
		}
		finally
		{
			Cleanup();
		}
		
		System.exit(0);
	}

}
